#!/usr/bin/env python
import rospy
from arrc.msg import Motspds
from sensor_msgs.msg import Joy
scaler = 400
turnscaler = 100

def move(data):
  if data.buttons[0] :
    zero = Motspds()
    zero.spds[:] = [scaler]*5
    spdpub.publish(zero)
    rospy.signal_shutdown("emergency stop")
  fwd = data.axes[1]
  turn = data.axes[2]
  up = data.axes[3]
  spds = Motspds()
  spds.spds[0] = scaler + scaler*fwd - turnscaler*turn #left motor
  spds.spds[1] = scaler + scaler*fwd + turnscaler*turn #right
  spds.spds[2] = scaler + scaler*up #top left
  spds.spds[3] = scaler - scaler*up #top right
  spds.spds[4] = scaler - scaler*up #back
  spdpub.publish(spds)


if __name__ == '__main__' :
  global spdpub
  rospy.init_node('Mover')
  joysub = rospy.Subscriber('joy', Joy, move)
  spdpub = rospy.Publisher('mspd', Motspds, queue_size=1)
  rospy.spin()
