#!/usr/bin/env python
import rospy
import time
from Adafruit_BNO055 import BNO055
#import ms5837
from sensor_msgs.msg import Imu #IMU
from std_msgs.msg import Bool #Leak Sensor
from std_msgs.msg import Float64 #pressure sensor
#from std_msgs.msg import Uint16 #Voltage monitor
import serial
from math import radians
bno = BNO055.BNO055(rst=18)
#pres = ms5837.MS5837_30BA() 
#init publishers here
imupub = rospy.Publisher('IMU', Imu, queue_size=1)
#batpub = rospy.Publisher('BAT', uint16, queue_size=1)
leakpub = rospy.Publisher('Leak', Bool, queue_size=1)
#prespub = rospy.Publisher('Depth', Float64, queue_size=1)
#ser = serial.Serial('/dev/ttyUSB0', 115200, timeout=0)
#rate = rospy.Rate(25) #25 hz might have to change later
def init_i2c() :
    # Initialize the BNO055 and stop if something went wrong.
    if not bno.begin():
        raise RuntimeError('Failed to initialize BNO055! Is the sensor connected?')
#    if not pres.init():
#        raise RuntimeError('Failed to initialize MS5837! Is the sensor connected?')

# Print system status and self test result.
    status, self_test, error = bno.get_system_status()
    print('System status: {0}'.format(status))
    print('Self test result (0x0F is normal): 0x{0:02X}'.format(self_test))
    # Print out an error if system status is in error mode.
    if status == 0x01:
        print('System error: {0}'.format(error))
        print('See datasheet section 4.3.59 for the meaning.')

def pubs() :
    imumsg = Imu()
    x, y, z, w = bno.read_quaternion()
    imumsg.orientation.x = x
    imumsg.orientation.y = y
    imumsg.orientation.z = z
    imumsg.orientation.w = w
    gx, gy, gz =map(radians, bno.read_gyroscope())
    imumsg.angular_velocity.x = gx
    imumsg.angular_velocity.y = gy
    imumsg.angular_velocity.z = gz
    ax, ay, az = bno.read_linear_acceleration()
    imumsg.linear_acceleration.x = ax
    imumsg.linear_acceleration.y = ay
    imumsg.linear_acceleration.z = az
    now = rospy.Time.now()
    imumsg.header.stamp.secs = now.secs
    imumsg.header.stamp.nsecs = now.nsecs
    imupub.publish(imumsg)
    #serin = ser.readline()
    #vals = serin.split(',')
    #batpub.publish(int(vals[0], 16))
    #if vals[1].count("!") > 0 :
    #    leakpub.publish(True)
    #else :
    #    leakpub.publish(False)
#    pres.read()
#    prespub.publish(pres.depth())
    
    
        
    
    

if __name__ == '__main__':
    #init node
    rospy.init_node('Peri')
    rate= rospy.Rate(10)
    init_i2c()
    try :
        while not rospy.is_shutdown() :
            pubs()
            rate.sleep()
    except rospy.ROSInterruptException:
        pass
        
    
    
