#!/usr/bin/env python
import rospy
from std_msgs.msg import Bool #Leak Sensor
from std_msgs.msg import UInt16 #Voltage monitor
from arrc.msg import Motspds
import serial
#init publishers here
batpub = rospy.Publisher('Bat', UInt16, queue_size=1)
leakpub = rospy.Publisher('Leak', Bool, queue_size=1)
ser = serial.Serial('/dev/ttyACM0', 115200, timeout=0.25)

def limitVal(val) :
    if val < 0:
        return 0
    elif val > 800:
        return 800
    else :
        return val

def subs(data) :
    mVals = data.spds
    mV = [limitVal(x) for x in mVals]
    buf = 0L
    buf = 0xFFFC000000000000 | ((mV[0] & 0x3FF) << 40) | ((mV[1] &0x3FF) << 30) | ((mV[2] &0x3FF) << 20) | ((mV[3] &0x3FF) << 10) | (mV[4] & 0x3FF)
    out = "!%X" % (buf)
    ser.write(out)

def pubs() :
    serin = ""
    while len(serin) < 5 or serin[0] != 'q' :
        serin = ser.readline()
    temp = serin[1:len(serin)-1]
    bat, leak = temp.split(',')
    batpub.publish(int(bat, 16))
    if leak.count("!") > 0 :
        leakpub.publish(True)
    else :
        leakpub.publish(False)    
    
        
    
    

if __name__ == '__main__':
    #init node
    rospy.init_node('Peri')
    rate= rospy.Rate(10)
    mSub = rospy.Subscriber('mspd', Motspds, subs)
    try :
        while not rospy.is_shutdown() :
            pubs()
            ser.reset_input_buffer()
            rate.sleep()
    except rospy.ROSInterruptException:
        pass
        
    
    
